package com.ims.eval.controller;


import com.ims.eval.entity.DataDictionary;
import com.ims.eval.entity.IndicatorDictionary;
import com.ims.eval.entity.dto.result.R;
import com.ims.eval.service.IDataDictionaryService;
import com.ims.system.auth.ImsPreAuth;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * <p>
 * 数据字典表 前端控制器
 * </p>
 *
 * @author wang
 * @since 2023-02-26
 */
@RestController
@RequestMapping("//data-dictionary")
public class DataDictionaryController {

	@Autowired
	private IDataDictionaryService dataDictionaryService;


	//@ImsPreAuth("eval:dataDictionary:view")
	@GetMapping(value = "list")
	public R list(@RequestParam(value = "id", required = false) String id,
									 @RequestParam(value = "dataKey", required = false) String dataKey,
									 @RequestParam(value = "keyName", required = false) String keyName,
									 @RequestParam(value = "superKey", required = false) String superKey ) {
		List<DataDictionary> list = dataDictionaryService.list(id,dataKey,keyName,superKey);
		return R.ok().data(list);
	}


	/**
	 * 添加
	 * @param dictionary
	 * @return
	 */

//	@ImsPreAuth("eval:dataDictionary:edit")
	@PostMapping(value = "/save")
	@ApiOperation(value = "新增(修改)", notes = "新增（修改）")
	public R addAll(@RequestBody DataDictionary dictionary) {

		boolean b = dataDictionaryService.saveOrUpdate(dictionary);
		if (b) {
			return R.ok().data(b);
		} else {
			return R.error().data("保存失败！");
		}
	}



}
