/**
 *
 */
package com.ims.eval.service.impl;

import com.ims.core.persistence.Page;
import com.ims.core.service.impl.CrudServiceImpl;
import com.ims.core.utils.IdGen;
import com.ims.eval.dao.EvaluateScoreDao;
import com.ims.eval.entity.EvaluateScore;
import com.ims.eval.service.IEvaluateScoreService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;


/**
 * 考评得分Service
 * @author wang
 * @version 2023-02-23
 */
@Service
@Transactional(readOnly = true)
public class EvaluateScoreServiceImpl extends CrudServiceImpl<EvaluateScoreDao, EvaluateScore> implements IEvaluateScoreService{

 	public EvaluateScore get(EvaluateScore evaluateScore) {
		return super.get(evaluateScore);
	}

    public List<EvaluateScore> findList(EvaluateScore evaluateScore) {
        return super.findList(evaluateScore);
    }

	public List<EvaluateScore> findAllListM(EvaluateScore evaluateScore,String dataFilter,String baseFilter,String key,String baseQuery,String specQuery) {
	 	return super.findAllListM(evaluateScore,dataFilter,baseFilter,key,baseQuery,specQuery);
	}

	public Page<EvaluateScore> findPageM(Page<EvaluateScore> page, EvaluateScore evaluateScore,String dataFilter,String baseFilter,String key,String baseQuery,String specQuery) {
		return super.findPageM(page, evaluateScore,dataFilter,baseFilter,key,baseQuery,specQuery);
	}

	public EvaluateScore initInsert(EvaluateScore evaluateScore)  {
		return super.initInsert(evaluateScore);
	}

	@Transactional(readOnly = false)
	public void checkSave(EvaluateScore evaluateScore) {
		super.checkSave(evaluateScore);
	}

	@Transactional(readOnly = false)
	public EvaluateScore save(EvaluateScore evaluateScore, boolean isNewRecord){
	    if(isNewRecord){
	        evaluateScore.setId(IdGen.uuid());
	    }
		return super.save(evaluateScore,isNewRecord);
	}

    @Transactional(readOnly = false)
    @Override
    public void insertList(List<EvaluateScore> list){
        super.insertList(list);
    }

	@Transactional(readOnly = false)
	public void checkRemove(EvaluateScore evaluateScore,String baseFilter){
		super.checkRemove(evaluateScore,baseFilter);
	}

	@Transactional(readOnly = false)
	public void delete(EvaluateScore evaluateScore,String baseFilter) {
		super.delete(evaluateScore,baseFilter);
	}
}
